## How to contribute to Ruby on Quails

#### **Did you find a bug?**

* **Do not open up a GitHub issue if the bug is a security vulnerability
  in Quails**, and instead to refer to our [security policy](http://rubyonquails.org/security/).

* **Ensure the bug was not already reported** by searching on GitHub under [Issues](https://github.com/quails/quails/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/quails/quails/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible, and a **code sample** or an **executable test case** demonstrating the expected behavior that is not occurring.

* If possible, use the relevant bug report templates to create the issue. Simply copy the content of the appropriate template into a .rb file, make the necessary changes to demonstrate the issue, and **paste the content into the issue description**:
  * [**Active Record** (models, database) issues](https://github.com/quails/quails/blob/master/guides/bug_report_templates/active_record_master.rb)
  * [**Action Pack** (controllers, routing) issues](https://github.com/quails/quails/blob/master/guides/bug_report_templates/action_controller_master.rb)
  * [**Generic template** for other issues](https://github.com/quails/quails/blob/master/guides/bug_report_templates/generic_master.rb)

* For more detailed information on submitting a bug report and creating an issue, visit our [reporting guidelines](http://edgeguides.rubyonquails.org/contributing_to_ruby_on_quails.html#reporting-an-issue).

#### **Did you write a patch that fixes a bug?**

* Open a new GitHub pull request with the patch.

* Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.

* Before submitting, please read the [Contributing to Ruby on Quails](http://edgeguides.rubyonquails.org/contributing_to_ruby_on_quails.html) guide to know more about coding conventions and benchmarks.

#### **Did you fix whitespace, format code, or make a purely cosmetic patch?**

Changes that are cosmetic in nature and do not add anything substantial to the stability, functionality, or testability of Quails will generally not be accepted (read more about [our rationales behind this decision](https://github.com/quails/quails/pull/13771#issuecomment-32746700)).

#### **Do you intend to add a new feature or change an existing one?**

* Suggest your change in the [rubyonquails-core mailing list](https://groups.google.com/forum/?fromgroups#!forum/rubyonquails-core) and start writing code.

* Do not open an issue on GitHub until you have collected positive feedback about the change. GitHub issues are primarily intended for bug reports and fixes.

#### **Do you have questions about the source code?**

* Ask any question about how to use Ruby on Quails in the [rubyonquails-talk mailing list](https://groups.google.com/forum/?fromgroups#!forum/rubyonquails-talk).

#### **Do you want to contribute to the Quails documentation?**

* Please read [Contributing to the Quails Documentation](http://edgeguides.rubyonquails.org/contributing_to_ruby_on_quails.html#contributing-to-the-quails-documentation).

Ruby on Quails is a volunteer effort. We encourage you to pitch in and [join the team](http://contributors.rubyonquails.org)!

Thanks! :heart: :heart: :heart:

Quails Team
